'..Self-Organizing cellular automaton.
'..cf "Digital Test Tube", Amazing Amiga, October 1992

defint a-z

dim olden(721),newen(721)

screen 1,640,200,3,2

palette 0,0,0,0
palette 1,1,1,1
palette 2,.8,0,.93
palette 3,1,.2,.27
palette 4,0,1,0

'..menu
color 4
locate 5,1:prints "1. Spiral"
locate 6,1:prints "2. Regeneration"
locate 7,1:prints "3. Diffusion"
locate 8,1:prints "4. My first seed"
locate 9,1:prints "5. My second seed"
locate 11,1:prints "   Hit Q to quit"

gosub setup

'..wait for a starting pattern to be chosen.
flg=1
repeat
 k$=inkey$
 if k$<>"" then gosub selection
until not flg
 
'..display pattern endlessly
'..responding to a request on demand.
while happy
 gosub display
 for x=40 to 680
  k$=inkey$
  if k$<>"" then gosub selection
  if olden(x) = 3 then 
    gosub changearound
  else
    if olden(x) = 2 then newen(x) = 1
  end if
 next
wend

'..change pattern according to below rules.
changearound:
 newen(x) = 2
 if olden(x-1) = 1 then newen(x-1) = 3
 if olden(x+1) = 1 then newen(x+1) = 3
 if olden(x+40) = 1 then newen(x+40) = 3
 if olden(x+41) = 1 then newen(x+41) = 3
 if olden(x+39) = 1 then newen(x+39) = 3
 if olden(x-40) = 1 then newen(x-40) = 3
 if olden(x-39) = 1 then newen(x-39) = 3
 if olden(x-41) = 1 then newen(x-41) = 3
return

'..show the current generation.
display:
 locate 4,1
 for y=1 to 16
   locate csrlin,19
   for x=1 to 40
     color newen(x+(y*40)),0
     olden(x+(y*40)) = newen(x+(y*40))
     prints chr$(31);
   next
   prints
 next
return
   
'..reset pattern.
setup:
 for i=0 to 721
  olden(i) = 1
  newen(i) = 1
 next
return

'..carry out a request.
selection:
 op=val(k$)
 case
  op=1 	: gosub spiral
  op=2 	: gosub regen
  op=3 	: gosub diff
  op=4 	: gosub my.seed
  op=5	: gosub my.second.seed
  ucase$(k$)="Q": screen close 1:stop
 end case
return


'..pattern seeds.

spiral:
 gosub setup
 for i=336 to 346:newen(i)=3:next
 newen(307)=3:newen(355)=2
 for i=295 to 306:newen(i)=2:next
 flg=0
return
  
regen:
 gosub setup
 newen(380)=3:newen(381)=3:newen(300)=3
 newen(301)=3:newen(339)=3:newen(340)=2
 flg=0
return

diff:
 gosub setup
 newen(340)=3
 flg=0
return

my.seed:
 gosub setup
 newen(340)=2
 newen(339)=3
 newen(341)=3
 newen(300)=3 
 newen(380)=3 
return

my.second.seed:
 gosub setup
 newen(336)=3
 newen(298)=2
 newen(340)=3
 newen(302)=2
 newen(344)=3
 newen(306)=2
 newen(348)=3
return
