'..Using intuition gadgets from ACE: boolean gadget.
'..Original code by David Benn. Modified by Michael Zielinski
'..to use WaitPort rather than busy waiting.
 
#include <intuition.h>

library intuition
library exec

declare function ModifyIDCMP& library intuition
declare function AddGadget library intuition
declare function RefreshGadgets library intuition

declare function WaitPort& library exec
declare function GetMsg& library exec
declare function ReplyMsg library exec

dim BoolGadgetPairs%(9)

for i=0 to 9
  read BoolGadgetPairs%(i)
next

data 0,0,61,0,61,21,0,21,0,0

declare struct Border BoolGadgetBorder
BoolGadgetBorder->LeftEdge   = -1
BoolGadgetBorder->TopEdge    = -1
BoolGadgetBorder->FrontPen   =  1
BoolGadgetBorder->BackPen    =  0
BoolGadgetBorder->DrawMode   =  JAM1
BoolGadgetBorder->Count      =  5
BoolGadgetBorder->XY         =  @BoolGadgetPairs%
BoolGadgetBorder->NextBorder =  NULL

declare struct IntuiText BoolGadgetText
BoolGadgetText->FrontPen     =  2
BoolGadgetText->BackPen      =  0
BoolGadgetText->DrawMode     =  JAM2
BoolGadgetText->LeftEdge     =  4
BoolGadgetText->TopEdge      =  7
BoolGadgetText->ITextFont    =  NULL
BoolGadgetText->IText        =  sadd("Gadget")
BoolGadgetText->NextText     =  NULL

declare struct Gadget BoolGad
BoolGad->NextGadget       = NULL
BoolGad->LeftEdge         = 100
BoolGad->TopEdge          = 100
BoolGad->Wdth             = 60
BoolGad->Height           = 20
BoolGad->Flags            = GADGHCOMP
BoolGad->Activation       = RELVERIFY
BoolGad->GadgetType       = BOOLGADGET
BoolGad->GadgetRender     = BoolGadgetBorder
BoolGad->SelectRender     = NULL
BoolGad->GadgetText       = BoolGadgetText
BoolGad->MutualExclude    = NULL
BoolGad->SpecialInfo      = NULL
BoolGad->GadgetID         = 1
BoolGad->UserData         = NULL


{ ** main ** }
longint Wdw,Wdw.UserPort,MsgClass,GadgetNr
declare struct IntuiMessage *message
declare struct Gadget *GadgetPtr

const UserPort = 86&
const IDCMP = 82&

screen 1,640,200,2,2

palette 0,0,0,0
palette 1,1,1,1
palette 2,0,1,0
palette 3,1,0,0

Wdw = window(7)
Wdw.UserPort = peekl(Wdw+UserPort)	'..could define Wdw structure instead

Flags& = peekl(Wdw+IDCMP) or (GADGETUP or GADGETDOWN)
ModifyIDCMP(Wdw,Flags&)

AddGadget(Wdw,BoolGad,1)
RefreshGadgets(BoolGad,Wdw,NULL)

repeat
  message = WaitPort(Wdw.UserPort)
  message = GetMsg(Wdw.UserPort)

  MsgClass = message->Class
  GadgetPtr = message->IAddress
  GadgetNr = GadgetPtr->GadgetID

  ReplyMsg(message) 
until MsgClass = GADGETUP

screen close 1

if MsgClass = GADGETUP then print "Gadget";GadgetNr;"was activated."

library close exec
library close intuition
