'...IFS-compressed image reconstructor

'...read probability levels, x & y factors and IFS data...

dim n%(4),xscale%(4),yscale%(4),xoffset%(4),yoffset%(4)

FOR R=1 TO 4
  read n%(r),xscale%(r),yscale%(r),xoffset%(r),yoffset%(r)
NEXT R

DATA 3,150,115,160,60
DATA 4,150,75,225,70
DATA 4,25,12,285,60
DATA 4,250,225,300,60
  
pt=0      '...reset probability counter

dim a(4,4),b(4,4),c(4,4),d(4,4),e(4,4),f(4,4),p(4,4)

FOR I=1 TO 3
  read a(1,I),b(1,I),c(1,I),d(1,I),e(1,I),f(1,I),pk
  pt=pt+pk
  p(1,I)=pt
NEXT I

FOR J=2 TO 4 
pt=0             '...reset probability counter 
  FOR L=1 TO 4
    read a(J,L)
    read b(J,L)
    read c(J,L)
    read d(J,L)
    read e(J,L)
    read f(J,L),pk
    pt=pt+pk
    p(J,L)=pt
  NEXT L
NEXT J

'...Sierpinski Triangle...

DATA .5,0,0,.5,0,0,.33
DATA .5,0,0,.5,1,0,.33
DATA .5,0,0,.5,.5,.5,.34

'...Square...

DATA .5,0,0,.5,0,0,.25
DATA .5,0,0,.5,.5,0,.25
DATA .5,0,0,.5,0,.5,.25
DATA .5,0,0,.5,.5,.5,.25

'...Fern...

DATA 0,0,0,.16,0,0,.01
DATA .2,-.26,.23,.22,0,1.6,.07
DATA -.15,.28,.26,.24,0,.44,.07
DATA .85,.04,-.04,.85,0,1.6,.85

'...Tree...

DATA 0,0,0,.5,0,0,.05
DATA .1,0,0,.1,0,.2,.15
DATA .42,-.42,.42,.42,0,.2,.4
DATA .42,.42,-.42,.42,0,.2,.4

declare function SetSoftStyle library graphics

screen 1,640,225,3,2

rport&=window(8)

const black=0,white=1,green=2,red=3,blue=4

palette black,0,0,0
palette white,1,1,1 
palette green,0,1,0 
palette red,1,0,0   
palette blue,.25,.25,1

const havingfun=1

while havingfun
 color black,black
 CLS

 color red,black
 locate 2,2:prints "---"
 locate 3,2:prints "IFS"
 locate 4,2:prints "---"

 color white,black
 locate 5,2:PRINTS "1] Sierpinski Triangle"
 locate 6,2:PRINTS "2] Square"
 locate 7,2:PRINTS "3] Fern"
 locate 8,2:PRINTS "4] Tree"

 color green,black
 locate 10,2:prints "Select 1..4 or q to quit"

 repeat  
   repeat
     op$=inkey$
   until op$<>""

   IF ucase$(op$)="Q" THEN 
     screen close 1
     stop
   END IF

   op%=VAL(op$)
 until op%>=1 and op%<=4

 '..which colour?
 color red,black
 locate 13,2:prints "Which color?"
 color white,black
 locate 14,2:prints "1. white"
 locate 15,2:prints "2. green"
 locate 16,2:prints "3. red"
 locate 17,2:prints "4. blue"
 color green,black
 locate 19,2:prints "Enter 1..4"
 
 repeat 
   repeat
     op$=inkey$
   until op$<>""

   fgnd%=val(op$)
 until fgnd%>=1 and fgnd%<=4

 '..initial x,y
 x=0
 y=0

 '...Do iterations
 color black,black
 CLS

 color red,white
 locate 23,30
 prints "press ";
 SetSoftStyle(rport&,2&,&Hff&)  '..bold 
 prints "s";
 SetSoftStyle(rport&,0&,&Hff&)  '..normal 
 prints " to stop";
 locate 24,30
 prints "or any other   ";
 locate 25,30
 prints "key for menu.  ";

 color fgnd%,black
 
 randomize timer

 i&=1
 repeat
  R=RND
  IF R <= p(op%,1) THEN 
     k%=1
  ELSE
     IF R <= p(op%,2) THEN 
        k%=2
     ELSE
        IF R <= p(op%,3) THEN k%=3 ELSE k%=n%(op%)
     end if
  END IF 
  newx = a(op%,k%) * x + b(op%,k%) * y + e(op%,k%)
  newy = c(op%,k%) * x + d(op%,k%) * y + f(op%,k%) 
  x=newx
  y=newy
  outX% = x * xscale%(op%) + xoffset%(op%)
  outY% = 200 - (y * yscale%(op%) + yoffset%(op%))  
  PSET (outX%,outY%)
  i&=i&+1
  key$=inkey$
 until i&>25000& or key$<>""

 '..hold screen?
 if key$="s" or i&>25000& then 
   while inkey$=""
   wend
 end if 

wend

screen close 1
